// +-------------------------------------------+
// |  ___   _     _____   __  __  ____   ____  |
// | | __| | |   | /_\ |  \ \/ / | ___| | /\ | |
// | |__ | | |_  |  _  |   \  /  | __|  | \/ / |
// | |___| |___| |_| |_|   |__|  |____| |_| \\ |
// |  Greek2me              Blockland ID 11902 |
// +-----------------------------+-------------+
// | DO NOT EDIT BELOW THIS LINE |
// +-----------------------------+

Slayer.Gamemodes.addMode("Bounty Hunter", "BH", false, true);

Slayer.Prefs.addPref("Bounty Hunter","Color Players","%mini.BH_colorNames","bool",1,0,1,-1,"Rules BH Mode");
Slayer.Prefs.addPref("Bounty Hunter","Label Free-kills in Chat","%mini.BH_labelFreekills","bool",0,0,1,-1,"Rules BH Mode");
Slayer.Prefs.addPref("Bounty Hunter","Non-Target Kill","%mini.BH_points_illKill","list" TAB "0 No Penalty" TAB "1 -1 Point" TAB "5 -5 Points" TAB "10 -10 Points" TAB "15 -15 Points" TAB "20 -20 Points" TAB "30 -30 Points" TAB "-1 Kill Attacker",-1,0,1,-1,"Rules BH Points");
Slayer.Prefs.addPref("Bounty Hunter","Kill Target","%mini.BH_points_target","int -999 999",10,0,0,-1,"Rules BH Points");
Slayer.Prefs.addPref("Bounty Hunter","Kill Hunter","%mini.BH_points_hunter","int -999 999",5,0,0,-1,"Rules BH Points");
Slayer.Prefs.addPref("Bounty Hunter","Freekill Penalty","%mini.BH_respawnPenalty_freeKill","int 0 999",10,0,1,-1,"Rules BH Respawn");

function serverCmdTarget(%client)
{
	%mini = getMinigameFromObject(%client);
	if(!isSlayerMinigame(%mini) || %mini.mode !$= "BH")
		return;

	if(isObject(%client.target))
	{
		if(%mini.BH_colorNames)
			%color = %client.target.colorHex;
		else
			%color = "ffff00";
		messageClient(%client,'',"\c5Your target is <color:" @ %color @ ">" @ %client.target.getPlayerName());
	}
	else
		%client.pickTarget();
}

function Slayer_BH_onModeStart(%mini)
{
	cancel(%mini.BH_tickSched);

	for(%i=0; %i < %mini.numMembers["GameConnection"]; %i++)
		%mini.member["GameConnection", %i].pickColor();
}

function Slayer_BH_onModeEnd(%mini)
{
	cancel(%mini.BH_tickSched);

	for(%i=0; %i < %mini.numMembers["GameConnection"]; %i++)
	{
		%cl = %mini.member["GameConnection", %i];
		%cl.hitList = "";
		%cl.target = "";
		%cl.colorHex = "";
		%cl.colorRGB = "";
	}
}

function Slayer_BH_onJoin(%mini,%client)
{
	%client.pickColor();
	%client.pickTarget();
	%client.pickHunter();

	for(%i=0; %i < %mini.numMembers["GameConnection"]; %i++)
	{
		%cl = %mini.member["GameConnection", %i];
		if(!strLen(%cl.hitList))
			continue;

		%cl.hitList = setField(%cl.hitList,getFieldCount(%cl.hitList),%client);
	}

	if(%client.colorRGB !$= "" && %mini.BH_colorNames && isObject(%client.player))
		%client.player.setBHColor(%client.colorRGB);
}

function Slayer_BH_onLeave(%mini,%client)
{
	for(%i=0; %i < %mini.numMembers["GameConnection"]; %i++)
	{
		%cl = %mini.member["GameConnection", %i];
		if(%cl.target == %client)
		{
			%cl.target = "";
			%cl.schedule(750,pickTarget);
		}

		if(%cl.hitList $= "")
			continue;

		%cnt = getFieldCount(%cl.hitList);
		for(%f=0; %f < %cnt; %f++)
		{
			%fld = getField(%cl.hitList,%f);
			if(%fld == %client)
				%cl.hitList = removeField(%cl.hitList,%f);
		}
	}

	%client.hitList = "";
	%client.target = "";
	%client.colorHex = "";
	%client.colorRGB = "";
}

function Slayer_BH_postReset(%mini)
{
	cancel(%mini.BH_tickSched);

	for(%i=0; %i < %mini.numMembers["GameConnection"]; %i++)
	{
		%cl = %mini.member["GameConnection", %i];
		%cl.hitList = "";
		%cl.target = "";
		%cl.pickTarget();
	}

	%mini.BH_tickSched = schedule(30000,0,Slayer_BH_TargetTick,%mini);
}

function Slayer_BH_onSpawn(%mini,%client)
{
	if(%client.colorRGB !$= "" && %mini.BH_colorNames && isObject(%client.player))
		%client.player.setBHColor(%client.colorRGB);
}

function Slayer_BH_postDeath(%mini,%client,%obj,%killer,%type,%area)
{
	if(%killer == %client || !isObject(%killer))
		return;

	if(%killer.target != %client && %client.target != %killer)
	{
		messageClient(%killer,'',"\c5Do not freekill! If you forgot who your target is, type \c3/target\c5 to find out.");
		%killer.bottomPrint("\c5Do not freekill! If you forgot who your target is, type \c3/target\c5 to find out.",5);
		%killer.incRespawnTime(%mini.BH_respawnPenalty_freeKill * 1000);

		%pun = %mini.BH_points_illKill;
		switch(%pun)
		{
			case -1:
				if(isObject(%killer.player))
					%killer.player.kill();

			default:
				%killer.incScore(%pun * -1);
		}
		return;
	}

	if(%killer.target == %client)
		%killer.incScore(%mini.BH_points_target);
	if(%client.target == %killer)
		%killer.incScore(%mini.BH_points_hunter);

	%killer.target = "";

	%killer.pickTarget();
	%client.pickHunter();
}

function isSpecialKill_Slayer_BH(%client, %sourceObject, %killer, %mini)
{
	if(!isSlayerMinigame(%mini) || %mini.mode !$= "BH" || 
		%killer == %client || !isObject(%killer) ||
		!isObject(%killer.target) && !isObject(%client.target) ||
		%killer.target != %client && %client.target != %killer
	)
	{
		return 0;
	}

	if(%killer.target == %client)
	{
		%value = "\c3(Target)";
		%add = 1;
	}
	if(%client.target == %killer)
	{
		if(%value $= "")
			%value = %value @ "\c3(Hunter)";
		else
			%value = %value SPC "\c3(Hunter)";
		%add = 1;
	}

	if(%add)
		return 2 TAB %value;
	else if(%mini.BH_labelFreekills)
		return 2 TAB "\c3(Free-kill)";
	else
		return 0;
}
addSpecialDamageMsg("Slayer_BH","%2%3%1 %4","");

function Slayer_BH_TargetTick(%mini)
{
	cancel(%mini.BH_tickSched);

	for(%i=0; %i < %mini.numMembers["GameConnection"]; %i++)
		serverCmdTarget(%mini.member["GameConnection", %i]);

	%mini.BH_tickSched = schedule(30000,0,Slayer_BH_TargetTick,%mini);
}

function GameConnection::pickTarget(%this)
{
	%mini = getMinigameFromObject(%this);
	if(!isSlayerMinigame(%mini) || %mini.mode !$= "BH")
		return;

	if(!strLen(%this.hitList)) //create a new hitlist
	{
		%cnt = 0;
		for(%i=0; %i < %mini.numMembers["GameConnection"]; %i++)
		{
			%m = %mini.member["GameConnection", %i];
			if(%this != %m)
			{
				%this.hitList = setField(%this.hitList,%cnt,%m);
				%cnt ++;
			}
		}
	}

	%r = getRandom(0,getFieldCount(%this.hitList)-1);
	%target = getField(%this.hitList,%r);
	%this.hitList = removeField(%this.hitList,%r);

	if(isObject(%target))
		%this.setTarget(%target);
}

function GameConnection::setTarget(%this,%target)
{
	if(!isObject(%target))
		return;

	%mini = getMinigameFromObject(%this);
	if(!isSlayerMinigame(%mini) || %mini.mode !$= "BH")
		return;

	%targetMini = getMinigameFromObject(%target);
	if(%targetMini != %mini)
		return;

	if(%target == %this)
	{
		if(%mini.numMembers["GameConnection"] > 1)
			%this.pickTarget();
		return;
	}

	%this.target = %target;

	if(%mini.BH_colorNames)
		%color = %this.target.colorHex;
	else
		%color = "ffff00";
	messageClient(%this,'',"\c5Your new target is <color:" @ %color @ ">" @ %this.target.getPlayerName() @ "\c5.");
	%this.bottomPrint("<just:center>\c5Your target is <color:" @ %color @ ">" @ %this.target.getPlayerName() @ "\c5.",5);
	schedule(getRandom(10000,20000),0,messageClient,%target,'',"\c5You are being hunted! Be careful.");
}

function GameConnection::pickHunter(%this) //checks for a client without a target and sets them to the client
{
	%mini = %this.minigame;
	if(!isSlayerMinigame(%mini))
		return;

	for(%i=0; %i < %mini.numMembers["GameConnection"]; %i++)
	{
		%cl = %mini.member["GameConnection", %i];
		if(%cl == %this)
			continue;
		if(isObject(%cl.target))
			continue;

		%hunter = %cl;
	}

	if(isObject(%hunter))
		%hunter.setTarget(%this);
}

function GameConnection::pickColor(%this)
{
	%mini = getMinigameFromObject(%this);
	if(!isSlayerMinigame(%mini) || %mini.mode !$= "BH")
		return;

	%rgb = getRandom(50,255) SPC getRandom(50,255) SPC getRandom(50,255);
	%rgba = getWord(%rgb,0) / 255 SPC getWord(%rgb,1) / 255 SPC getWord(%rgb,2) / 255 SPC 1;
	%hex = Slayer_Support::RgbToHex(%rgb);

	%this.colorRGB = %rgba;
	%this.colorHex = %hex;

	if(%mini.BH_colorNames && isObject(%this.player))
		%this.player.setBHColor(%rgba);
}

function Player::setBHColor(%this, %rgba)
{
	%this.setShapeNameColor(%rgba);
	%this.setNodeColor("chest", %rgba);
	%this.setNodeColor("femChest", %rgba);
	%this.setNodeColor("armor", %rgba);
	%this.setNodeColor("bucket", %rgba);
	%this.setNodeColor("cape", %rgba);
	%this.setNodeColor("pack", %rgba);
	%this.setNodeColor("quiver", %rgba);
	%this.setNodeColor("tank", %rgba);
}